POJ 1958 Strange Towers of Hanoi (线性dp 推公式)


Strange Towers of Hanoi
Time Limit: 1000MS Memory Limit: 30000K
Total Submissions: 2506 Accepted: 1662

Description

Background
Charlie Darkbrown sits in another one of those boring Computer Science lessons: At the moment the teacher just explains the standard Tower of Hanoi problem, which bores Charlie to death!

The teacher points to the blackboard (Fig. 4) and says: "So here is the problem:
  • There are three towers: A, B and C.
  • There are n disks. The number n is constant while working the puzzle.
  • All disks are different in size.
  • The disks are initially stacked on tower A increasing in size from the top to the bottom.
  • The goal of the puzzle is to transfer all of the disks from tower A to tower C.
  • One disk at a time can be moved from the top of a tower either to an empty tower or to a tower with a larger disk on the top.

So your task is to write a program that calculates the smallest number of disk moves necessary to move all the disks from tower A to C."
Charlie: "This is incredibly boring—everybody knows that this can be solved using a simple recursion.I deny to code something as simple as this!"
The teacher sighs: "Well, Charlie, let's think about something for you to do: For you there is a fourth tower D. Calculate the smallest number of disk moves to move all the disks from tower A to tower D using all four towers."
Charlie looks irritated: "Urgh. . . Well, I don't know an optimal algorithm for four towers. . . "
Problem
So the real problem is that problem solving does not belong to the things Charlie is good at. Actually, the only thing Charlie is really good at is "sitting next to someone who can do the job". And now guess what — exactly! It is you who is sitting next to Charlie, and he is already glaring at you.
Luckily, you know that the following algorithm works for n <= 12: At first k >= 1 disks on tower A are fixed and the remaining n-k disks are moved from tower A to tower B using the algorithm for four towers.Then the remaining k disks from tower A are moved to tower D using the algorithm for three towers. At last the n - k disks from tower B are moved to tower D again using the algorithm for four towers (and thereby not moving any of the k disks already on tower D). Do this for all k 2 ∈{1, .... , n} and find the k with the minimal number of moves.
So for n = 3 and k = 2 you would first move 1 (3-2) disk from tower A to tower B using the algorithm for four towers (one move). Then you would move the remaining two disks from tower A to tower D using the algorithm for three towers (three moves). And the last step would be to move the disk from tower B to tower D using again the algorithm for four towers (another move). Thus the solution for n = 3 and k = 2 is 5 moves. To be sure that this really is the best solution for n = 3 you need to check the other possible values 1 and 3 for k. (But, by the way, 5 is optimal. . . )

Input

There is no input.

Output

For each n (1 <= n <= 12) print a single line containing the minimum number of moves to solve the problem for four towers and n disks.

Sample Input

No input.

Sample Output

REFER TO OUTPUT.

Source

TUD Programming Contest 2002, Darmstadt, Germany


题目链接 :http://poj.org/problem?id=1958

题目大意:4个塔的汉诺塔问题,输出1-12的解

题目分析:设f(k, n)为k个塔,n个盘子下移动盘子的最小次数,则f(k, n) = (1 <= m < n) min(f(k, n), 2*f(k, m) + f(k-1 , n-m))
因为我们必定从n个盘子中先选出m个放到中间的某个塔上,次数为f(k,m)然后将剩下的n-m到n个盘子通过剩下的k-1个塔移动到目标塔,次数为f(k - 1, n - m),最后再把那m个移动到目标塔上,次数为f(k,m)所以最后的在(1 <= m < n)的范围中,对f(k,n)取个最小值,      因为3个塔的汉诺塔问题的解公式为 2^n - 1,所以我们先把3个塔的情况预处理出来,4个塔通过dp得到解。


//通式dp解法
#include <cstdio>
#include <algorithm>
#include <cstring>
using namespace std;
int dp[20][20];
int main()
{
    int tmp = 1;
    for(int i = 1; i <= 20; i++)
        for(int j = 1; j <= 20; j++)
            dp[i][j] = 0xfffffff;
    for(int i = 1; i < 20; i++)
    {
        dp[3][i] = tmp * 2 - 1;
        tmp *= 2;
        dp[i][1] = 1;
    }
    for(int i = 4; i <= 20; i++)
        for(int j = 1; j <= 20; j++)
            for(int k = 1; k < j; k++)
                dp[i][j] = min(dp[i][j], 2 * dp[i][k] + dp[i - 1][j - k]);
    for(int i = 1; i < 13; i++)
        printf("%d\n", dp[4][i]);
}


  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值